///RAYMOND PAI
///SECTION D
///RPAI@ANDREW.CMU.EDU
///FINAL PROJECT

//Camera
var capture;
var tracker;
var positions;
// background color random
var r, g, b;


function setup() {
  w = 600;
  h = 600;

  //setup camera
  capture = createCapture(VIDEO);
  createCanvas(w, h);
  capture.size(w, h);
  capture.hide();
  tracker = new clm.tracker();
  tracker.init();
  tracker.start(capture.elt);

  //random background color generator
  r = random(255);
  g = random(255);
  b = random(255);

  //background color randomize
  background(r, g, b);

  //slider for brush stroke control
  //size range based on what is small enough to see and not too big to full the screen at once
  slider = createSlider(50, 200, 120);
}

function draw() {
  
  //Half tone grid
  //nested for loop continued through drawRow function below
  for (var i = 5; i < height - 70; i += 50) {
    drawRow(i, 30);
  }
  //User messages
  textSize(14);
  fill(255);
  text('(Face the screen. You must be in a well lit environment for this to work.)', 10, 580);
  text('Press Space = reset canvas/ Slider adjusts brush size/ Click border = reveal halftone->', 10, 100);
  textSize(42);
  text('Move your face to create.', 10, 60);
  
  //space to reveal halftone
  fill(0);
  rect(550, 0, 600, 600);

  //Camera picks up flipped image, this unflips this image and makes it appear natural to the user as a mirror would
  translate(w, 0);
  scale(-1.0, 1.0);
  //eye tracker sourced from clmtrackr
  positions = tracker.getCurrentPosition();

  if (positions.length > 0) {

    // left eye tracker: https://www.auduno.com/clmtrackr/docs/reference.html
    //eye is an x and y input, which is used by the brush to move in relation to the user's facial movements
    const eye = {
      outline: [23, 63, 24, 64, 25, 65, 26, 66].map(getPoint),
      center: getPoint(27),
      top: getPoint(24),
      bottom: getPoint(26)
    };
    //draw brush (function below)
    drawBrush(eye)
  }
}

//eye tracker, updating location of the user's eye
function getPoint(index) {
  return createVector(positions[index][0], positions[index][1]);
}

function drawBrush(eye) {
  //draws a stroke based on the eye position
  //slider for user to control brush stroke
  var r = random(150, 200)
  var g = random(150, 200)
  var b = random(150, 200)
  
  var brushSize = slider.value();
  noStroke();
  fill(r, g, b);
  ellipse(eye.center.x, eye.center.y, brushSize, brushSize);
}

//clear background
//use instructions say press space for simplicity
function keyPressed() {
  background(r, g, b);
}

function drawRow(y, spacing) {
    //hard coded spacing through trials
    spacing = 50;
    //for loop to draw rows of circles
    for (var x = 7; x < width - 7; x += spacing) {
        strokeWeight(0);
        fill(r, g, b);
        ellipse(x, y, 35, 35);
    }
}

//reveal half tone
function mousePressed() {
  //if user clicks in the section highlighted on the right, the pattern is revealed through color change
  if (mouseX > 550 && mouseX < 600){
    r = random(150, 200)
    g = random(150, 200)
    b = random(150, 200)
  }
}